<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Other Data</TITLE>
<link href="suif1_7.html" rel=Next>
<link href="suif1_5.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_5.html">previous</A>, <A HREF="suif1_7.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC6" HREF="suif1_toc.html#TOC6">Other Data</A></H2>

<P>
SUIF is designed to be extended with new kinds of analyses and
optimizations.  These future extensions will generally require that
additional information be attached to SUIF objects and propagated
between passes.  For example, one pass may analyze the SUIF code and
produce information about data dependences.  That information must be
saved in the SUIF files so that it can be used by other passes.  Because
many different kinds of information may need to be stored, the SUIF
library cannot predefine specific fields for future extensions.
Instead, it provides <STRONG>annotations</STRONG> which allow user-defined data
structures to be attached to most SUIF objects.  See section <A HREF="suif1_69.html#SEC69">Annotations</A>.
This is the primary mechanism for making SUIF easily extensible.

</P>
<P>
Several different kinds of annotations are available.  They all include
a name field that identifies the kind of data in the annotation.
Besides the name, each annotation has some sort of data.  A
<STRONG>structured</STRONG> annotation contains data in a user-defined data
structure, whereas a <STRONG>flat</STRONG> annotation consists of a list of
immediate values.  The names of structured and flat annotations are
registered with the <STRONG>annotation manager</STRONG>.  See section <A HREF="suif1_79.html#SEC79">Annotation Manager</A>.  The manager records information about each kind of
annotation, such as whether they are flat or structured and whether they
should be written to the output files.

</P>
<P>
Annotations can also be used without registering them with the manager.
To be able to write annotations to output files, SUIF must be able to
represent them as lists of immediate values <A NAME="DOCF1" HREF="suif1_foot.html#FOOT1">(1)</A>.  Because unregistered annotations are not
written to the output files, they may contain arbitrary data structures.
Obviously, they can only be used internally within one pass.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_5.html">previous</A>, <A HREF="suif1_7.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
